# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_dock_msgs/TargetTrackerState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class TargetTrackerState(genpy.Message):
  _md5sum = "9df88697cdefd86518878614477e9317"
  _type = "clearpath_dock_msgs/TargetTrackerState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition containing the state information of the target tracker.
# This includes whether or not the tracker is active, whether the target is visible/lost, and the target pose and score of that pose.

bool active

# flag indicates if the target is visible or not
bool target_locked

geometry_msgs/PoseWithCovarianceStamped target_pose
float32 score

# the distance of the sensor_link to the dock target
float64 distance_to_target



================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['active','target_locked','target_pose','score','distance_to_target']
  _slot_types = ['bool','bool','geometry_msgs/PoseWithCovarianceStamped','float32','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       active,target_locked,target_pose,score,distance_to_target

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TargetTrackerState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.active is None:
        self.active = False
      if self.target_locked is None:
        self.target_locked = False
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      if self.score is None:
        self.score = 0.
      if self.distance_to_target is None:
        self.distance_to_target = 0.
    else:
      self.active = False
      self.target_locked = False
      self.target_pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      self.score = 0.
      self.distance_to_target = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B3I().pack(_x.active, _x.target_locked, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs))
      _x = self.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.target_pose.pose.pose.position.x, _x.target_pose.pose.pose.position.y, _x.target_pose.pose.pose.position.z, _x.target_pose.pose.pose.orientation.x, _x.target_pose.pose.pose.orientation.y, _x.target_pose.pose.pose.orientation.z, _x.target_pose.pose.pose.orientation.w))
      buff.write(_get_struct_36d().pack(*self.target_pose.pose.covariance))
      _x = self
      buff.write(_get_struct_fd().pack(_x.score, _x.distance_to_target))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.active, _x.target_locked, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs,) = _get_struct_2B3I().unpack(str[start:end])
      self.active = bool(self.active)
      self.target_locked = bool(self.target_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.target_pose.pose.pose.position.x, _x.target_pose.pose.pose.position.y, _x.target_pose.pose.pose.position.z, _x.target_pose.pose.pose.orientation.x, _x.target_pose.pose.pose.orientation.y, _x.target_pose.pose.pose.orientation.z, _x.target_pose.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 288
      self.target_pose.pose.covariance = _get_struct_36d().unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.score, _x.distance_to_target,) = _get_struct_fd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B3I().pack(_x.active, _x.target_locked, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs))
      _x = self.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.target_pose.pose.pose.position.x, _x.target_pose.pose.pose.position.y, _x.target_pose.pose.pose.position.z, _x.target_pose.pose.pose.orientation.x, _x.target_pose.pose.pose.orientation.y, _x.target_pose.pose.pose.orientation.z, _x.target_pose.pose.pose.orientation.w))
      buff.write(self.target_pose.pose.covariance.tostring())
      _x = self
      buff.write(_get_struct_fd().pack(_x.score, _x.distance_to_target))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseWithCovarianceStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.active, _x.target_locked, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs,) = _get_struct_2B3I().unpack(str[start:end])
      self.active = bool(self.active)
      self.target_locked = bool(self.target_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.target_pose.pose.pose.position.x, _x.target_pose.pose.pose.position.y, _x.target_pose.pose.pose.position.z, _x.target_pose.pose.pose.orientation.x, _x.target_pose.pose.pose.orientation.y, _x.target_pose.pose.pose.orientation.z, _x.target_pose.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 288
      self.target_pose.pose.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      _x = self
      start = end
      end += 12
      (_x.score, _x.distance_to_target,) = _get_struct_fd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B3I = None
def _get_struct_2B3I():
    global _struct_2B3I
    if _struct_2B3I is None:
        _struct_2B3I = struct.Struct("<2B3I")
    return _struct_2B3I
_struct_36d = None
def _get_struct_36d():
    global _struct_36d
    if _struct_36d is None:
        _struct_36d = struct.Struct("<36d")
    return _struct_36d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_fd = None
def _get_struct_fd():
    global _struct_fd
    if _struct_fd is None:
        _struct_fd = struct.Struct("<fd")
    return _struct_fd
