// Auto-generated. Do not edit!

// (in-package clearpath_dock_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class DockInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.uuid = null;
      this.frame = null;
      this.target_template = null;
      this.last_location_set_time = null;
      this.max_predock_distance = null;
      this.predock_distance = null;
      this.latitude = null;
      this.longitude = null;
      this.heading = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('frame')) {
        this.frame = initObj.frame
      }
      else {
        this.frame = '';
      }
      if (initObj.hasOwnProperty('target_template')) {
        this.target_template = initObj.target_template
      }
      else {
        this.target_template = '';
      }
      if (initObj.hasOwnProperty('last_location_set_time')) {
        this.last_location_set_time = initObj.last_location_set_time
      }
      else {
        this.last_location_set_time = '';
      }
      if (initObj.hasOwnProperty('max_predock_distance')) {
        this.max_predock_distance = initObj.max_predock_distance
      }
      else {
        this.max_predock_distance = 0.0;
      }
      if (initObj.hasOwnProperty('predock_distance')) {
        this.predock_distance = initObj.predock_distance
      }
      else {
        this.predock_distance = 0.0;
      }
      if (initObj.hasOwnProperty('latitude')) {
        this.latitude = initObj.latitude
      }
      else {
        this.latitude = 0.0;
      }
      if (initObj.hasOwnProperty('longitude')) {
        this.longitude = initObj.longitude
      }
      else {
        this.longitude = 0.0;
      }
      if (initObj.hasOwnProperty('heading')) {
        this.heading = initObj.heading
      }
      else {
        this.heading = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DockInfo
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [frame]
    bufferOffset = _serializer.string(obj.frame, buffer, bufferOffset);
    // Serialize message field [target_template]
    bufferOffset = _serializer.string(obj.target_template, buffer, bufferOffset);
    // Serialize message field [last_location_set_time]
    bufferOffset = _serializer.string(obj.last_location_set_time, buffer, bufferOffset);
    // Serialize message field [max_predock_distance]
    bufferOffset = _serializer.float32(obj.max_predock_distance, buffer, bufferOffset);
    // Serialize message field [predock_distance]
    bufferOffset = _serializer.float32(obj.predock_distance, buffer, bufferOffset);
    // Serialize message field [latitude]
    bufferOffset = _serializer.float64(obj.latitude, buffer, bufferOffset);
    // Serialize message field [longitude]
    bufferOffset = _serializer.float64(obj.longitude, buffer, bufferOffset);
    // Serialize message field [heading]
    bufferOffset = _serializer.float64(obj.heading, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DockInfo
    let len;
    let data = new DockInfo(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [frame]
    data.frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [target_template]
    data.target_template = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [last_location_set_time]
    data.last_location_set_time = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [max_predock_distance]
    data.max_predock_distance = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [predock_distance]
    data.predock_distance = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [latitude]
    data.latitude = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [longitude]
    data.longitude = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [heading]
    data.heading = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.name);
    length += _getByteLength(object.uuid);
    length += _getByteLength(object.frame);
    length += _getByteLength(object.target_template);
    length += _getByteLength(object.last_location_set_time);
    return length + 52;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_dock_msgs/DockInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '437fbd393595a29f96726ac5224b1d5b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition containing the information of a single dock. This includes identifiers, lat/lon and orientation of the dock.
    
    string name
    string uuid
    string frame
    string target_template
    
    # ISO 8601 date/time format of last successfull dock location setting
    string last_location_set_time
    
    # maximum allowable distance to allow for predocking. (ie. the distance within which the dock waypoint must be located)
    float32 max_predock_distance
    # the distance from the dock that the robot will navigate to prior to start docking
    float32 predock_distance
    
    # location of the dock
    float64 latitude
    float64 longitude
    float64 heading
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DockInfo(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.frame !== undefined) {
      resolved.frame = msg.frame;
    }
    else {
      resolved.frame = ''
    }

    if (msg.target_template !== undefined) {
      resolved.target_template = msg.target_template;
    }
    else {
      resolved.target_template = ''
    }

    if (msg.last_location_set_time !== undefined) {
      resolved.last_location_set_time = msg.last_location_set_time;
    }
    else {
      resolved.last_location_set_time = ''
    }

    if (msg.max_predock_distance !== undefined) {
      resolved.max_predock_distance = msg.max_predock_distance;
    }
    else {
      resolved.max_predock_distance = 0.0
    }

    if (msg.predock_distance !== undefined) {
      resolved.predock_distance = msg.predock_distance;
    }
    else {
      resolved.predock_distance = 0.0
    }

    if (msg.latitude !== undefined) {
      resolved.latitude = msg.latitude;
    }
    else {
      resolved.latitude = 0.0
    }

    if (msg.longitude !== undefined) {
      resolved.longitude = msg.longitude;
    }
    else {
      resolved.longitude = 0.0
    }

    if (msg.heading !== undefined) {
      resolved.heading = msg.heading;
    }
    else {
      resolved.heading = 0.0
    }

    return resolved;
    }
};

module.exports = DockInfo;
