// Auto-generated. Do not edit!

// (in-package clearpath_dock_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DockInfo = require('../msg/DockInfo.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class AddDockRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.dock = null;
    }
    else {
      if (initObj.hasOwnProperty('dock')) {
        this.dock = initObj.dock
      }
      else {
        this.dock = new DockInfo();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddDockRequest
    // Serialize message field [dock]
    bufferOffset = DockInfo.serialize(obj.dock, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddDockRequest
    let len;
    let data = new AddDockRequest(null);
    // Deserialize message field [dock]
    data.dock = DockInfo.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += DockInfo.getMessageSize(object.dock);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_dock_msgs/AddDockRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '08bff465f96eaa6cdc08ce0f80cdc44d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Service definition to add a dock to the list of available docks
    
    # A dock information message for the dock to be added
    clearpath_dock_msgs/DockInfo dock
    
    ================================================================================
    MSG: clearpath_dock_msgs/DockInfo
    # Message definition containing the information of a single dock. This includes identifiers, lat/lon and orientation of the dock.
    
    string name
    string uuid
    string frame
    string target_template
    
    # ISO 8601 date/time format of last successfull dock location setting
    string last_location_set_time
    
    # maximum allowable distance to allow for predocking. (ie. the distance within which the dock waypoint must be located)
    float32 max_predock_distance
    # the distance from the dock that the robot will navigate to prior to start docking
    float32 predock_distance
    
    # location of the dock
    float64 latitude
    float64 longitude
    float64 heading
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddDockRequest(null);
    if (msg.dock !== undefined) {
      resolved.dock = DockInfo.Resolve(msg.dock)
    }
    else {
      resolved.dock = new DockInfo()
    }

    return resolved;
    }
};

class AddDockResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.message = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AddDockResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = _serializer.string(obj.message, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AddDockResponse
    let len;
    let data = new AddDockResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.message);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_dock_msgs/AddDockResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '937c9679a518e3a18d831e57125ea522';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # True if the dock has been added successfully, otherwise False
    bool success
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AddDockResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.message !== undefined) {
      resolved.message = msg.message;
    }
    else {
      resolved.message = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: AddDockRequest,
  Response: AddDockResponse,
  md5sum() { return '1744110820759892f5237b8ba9349328'; },
  datatype() { return 'clearpath_dock_msgs/AddDock'; }
};
