// Auto-generated. Do not edit!

// (in-package clearpath_dock_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let DockInfo = require('../msg/DockInfo.js');

//-----------------------------------------------------------

class ImportDataRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataRequest
    // Serialize message field [data]
    bufferOffset = _serializer.string(obj.data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataRequest
    let len;
    let data = new ImportDataRequest(null);
    // Deserialize message field [data]
    data.data = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.data);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_dock_msgs/ImportDataRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '992ce8a1687cec8c8bd883ec73ca41d1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A JSON string representing the database contents.
    # This is the same as the data output by the ExportData service, and is intended
    # to be used to restore the database to a previous state
    string data
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataRequest(null);
    if (msg.data !== undefined) {
      resolved.data = msg.data;
    }
    else {
      resolved.data = ''
    }

    return resolved;
    }
};

class ImportDataResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.docks = null;
    }
    else {
      if (initObj.hasOwnProperty('docks')) {
        this.docks = initObj.docks
      }
      else {
        this.docks = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataResponse
    // Serialize message field [docks]
    // Serialize the length for message field [docks]
    bufferOffset = _serializer.uint32(obj.docks.length, buffer, bufferOffset);
    obj.docks.forEach((val) => {
      bufferOffset = DockInfo.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataResponse
    let len;
    let data = new ImportDataResponse(null);
    // Deserialize message field [docks]
    // Deserialize array length for message field [docks]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.docks = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.docks[i] = DockInfo.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.docks.forEach((val) => {
      length += DockInfo.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_dock_msgs/ImportDataResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'aa88a2d7ca6c8e5adf72c90d078c6ca9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The state of the database after importing the data
    clearpath_dock_msgs/DockInfo[] docks
    
    
    ================================================================================
    MSG: clearpath_dock_msgs/DockInfo
    # Message definition containing the information of a single dock. This includes identifiers, lat/lon and orientation of the dock.
    
    string name
    string uuid
    string frame
    string target_template
    
    # ISO 8601 date/time format of last successfull dock location setting
    string last_location_set_time
    
    # maximum allowable distance to allow for predocking. (ie. the distance within which the dock waypoint must be located)
    float32 max_predock_distance
    # the distance from the dock that the robot will navigate to prior to start docking
    float32 predock_distance
    
    # location of the dock
    float64 latitude
    float64 longitude
    float64 heading
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataResponse(null);
    if (msg.docks !== undefined) {
      resolved.docks = new Array(msg.docks.length);
      for (let i = 0; i < resolved.docks.length; ++i) {
        resolved.docks[i] = DockInfo.Resolve(msg.docks[i]);
      }
    }
    else {
      resolved.docks = []
    }

    return resolved;
    }
};

module.exports = {
  Request: ImportDataRequest,
  Response: ImportDataResponse,
  md5sum() { return '546f36388dd432f3d8cd2f98081b5205'; },
  datatype() { return 'clearpath_dock_msgs/ImportData'; }
};
